#include <stdlib.h>
#include "glut.h"
#include <iostream>

int vp_width = 1;
int vp_height = 1;
const int startWindowWidth = 512;
const int startWindowHeight = 512;
unsigned char gKeys[256];

void initialize();
void Terminate(void);
void idle();
void normalKeys(unsigned char key, int x,int y);
void specialKeys(int key, int x,int y);
void KeyboardUpCallback(unsigned char key, int x, int y);
void move(int x, int y);
void mouse(int button, int state, int x, int y);
void reshape(int width, int height);

void displayResult(int w,int h)
{
	float z = 0.0f;

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	// 1st Trible: position of camera in world coordinate space
	// 2nd Trible: camera view direction vector
	// 3rd Trible: camera up vector
	gluLookAt (0.0, 0.0, 16.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

	glTranslatef(0.f,0.f,0.0f);

	glColor3f(1.0f,0.0f,0.0f);

	//glLineWidth(3.0f);
	//glBegin(GL_LINES);
	//glColor3f(1.0f,0.0f,0.0f);
	//glVertex3f(0.0f,0.0f,0.0f);
	//glVertex3f(1.0,0.0f,0.0f);
	//glColor3f(0.0f,1.0f,0.0f);
	//glVertex3f(0.0f,0.0f,0.0f);
	//glVertex3f(0.0,1.0f,0.0f);
	//glColor3f(0.0f,0.0f,1.0f);
	//glVertex3f(0.0f,0.0f,0.0f);
	//glVertex3f(0.0,0.0f,1.0f);
	//glEnd();
	
	glTranslatef( 2.f, 0.f, 0.f );
	glRotatef( 45.f, 0.f, 0.f, 1.f );
	glutWireTeapot(1.0);
	//glutSolidCube(2.0);

	//glBegin(GL_QUADS);
	//glVertex3f(-0.5f,-0.5f,z);
	//glVertex3f(0.5f,-0.5f,z);
	//glVertex3f(0.5f,0.5f,z);
	//glVertex3f(-0.5f,0.5f,z);
	//glEnd();

	glPopMatrix();

}

//! Call-back function for GLUT display
void display()
{
	glClear(GL_COLOR_BUFFER_BIT  );
	displayResult(vp_width, vp_height);
	glutSwapBuffers();
}

int main(int argc, char* argv[])
{
	glutInit(&argc, argv);
	initialize();
	glutMainLoop();
	return 0;
}

void initialize()
{
	glutInitDisplayMode( GLUT_DOUBLE  | GLUT_RGBA | GLUT_DEPTH);
	glutInitWindowPosition(0,0);
	glutInitWindowSize(startWindowWidth,startWindowHeight);
	glutCreateWindow("MyWindow");
	glutIdleFunc(idle);
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);
	glutMotionFunc(move);
	glutKeyboardFunc(normalKeys);
	glutSpecialFunc(specialKeys);
    glClearColor(.0f,.0f,.0f,.0f);

	atexit(Terminate);	// Called after glutMainLoop ends
}

void idle()
{ glutPostRedisplay(); }

void normalKeys(unsigned char key, int x,int y)
{
	gKeys[key] = false;
    switch (key)
        {
        case 27 :
            {
            exit(0); break; 
            }
	}
}

//! Call-back function for GLUT reshape
void reshape(int width, int height) {

	int h = height;
	int w = width;

	if(h == 0)
		h = 1;

	float ratio = 1.0* w / h;

	glViewport(0, 0, w, h);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	//Near field and far field ALWAYS relative to viewing plane
	//For gluLookAt the world coordinate position + the gluPerspective nearField give the 
	// near field clipping plane in world coordinates
	gluPerspective(45,ratio,2,100);
	//glOrtho(-2,2,-2,2,-2,2);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	vp_width = width; 
	vp_height = height;	
}

void specialKeys(int key, int x,int y)
{}

void move(int x, int y)
{}

void mouse(int button, int state, int x, int y)
{}

// Function called at exit
void Terminate(void)
{}