#include <stdlib.h>
#include "glut.h"
#include <iostream>



int vp_width = 1;
int vp_height = 1;
const int startWindowWidth = 512;
const int startWindowHeight = 512;
unsigned char gKeys[256];


void initialize();
void Terminate(void);
void idle();
void normalKeys(unsigned char key, int x,int y);
void specialKeys(int key, int x,int y);
void KeyboardUpCallback(unsigned char key, int x, int y);
void move(int x, int y);
void mouse(int button, int state, int x, int y);
void reshape(int width, int height);

GLfloat light_ambient[] = { 0.0f, 1.0f, 1.0f, 1.0f };
GLfloat light_diffuse[] = { 0.0f, 1.0f, 0.0f, 1.0f };
GLfloat light_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };


void displayResult(int w,int h)
{

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();


	// 1st Trible: position of camera in world coordinate space
	// 2nd Trible: camera view direction vector
	// 3rd Trible: camera up vector
	gluLookAt (0.0, 0.0, 15.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

	
	
	glRotatef(45.f, 0.f,0.f,1.f);
	glTranslatef(3.f,0.f,0.0f);
	
	//glColor3f(1.0f,0.0f,0.0f);
	glutSolidTeapot(1.0);
			
	glPopMatrix();

}

GLfloat material_Ka[] = { 1.0f, 0.06f, 0.11f, 1.0f};
GLfloat material_Kd[] = { 0.43f, 0.47f, 0.54f, 1.0f};
GLfloat material_Ks[] = { 1.f, 1.f, 1.f, 1.f};
GLfloat material_Ke[] = { 0.0f, 0.0f, 0.0f, 1.0f};
GLfloat material_Se = 10.0f;
//! Call-back function for GLUT display
void display()
{
	glEnable(GL_DEPTH_TEST);
	glClearDepth(1.0f);
	glDepthFunc(GL_LEQUAL);
	glShadeModel(GL_FLAT);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
	glLightfv(GL_LIGHT0, GL_POSITION, light_position); 


	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material_Ka);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material_Kd);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material_Ks);
	glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, material_Ke);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, material_Se);

	//glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	//glEnable(GL_COLOR_MATERIAL);


	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	displayResult(vp_width, vp_height);
	glutSwapBuffers();

}



int main(int argc, char* argv[])
{
	glutInit(&argc, argv);
	initialize();
	glutMainLoop();
	return 0;
}

void initialize()
{
	glutInitDisplayMode( GLUT_DOUBLE  | GLUT_RGBA | GLUT_DEPTH);
	glutInitWindowPosition(0,0);
	glutInitWindowSize(startWindowWidth,startWindowHeight);
	glutCreateWindow("MyWindow");
	glutIdleFunc(idle);
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);
	glutMotionFunc(move);
	glutKeyboardFunc(normalKeys);
	glutSpecialFunc(specialKeys);
    glClearColor(1.0f,1.0f,0.0f,.0f);
	glClearColor(1.0f,1.0f,1.0f,1.0f);

	atexit(Terminate);	// Called after glutMainLoop ends

}




void idle()
{ glutPostRedisplay(); }

void normalKeys(unsigned char key, int x,int y)
{
	gKeys[key] = false;
    switch (key)
        {
        case 27 :
            {
            exit(0); break; 
            }
	}
}



//! Call-back function for GLUT reshape
void reshape(int width, int height) {

	int h = height;
	int w = width;

	if(h == 0)
		h = 1;

	float ratio = 1.0* w / h;

	glViewport(0, 0, w, h);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//Near field and far field ALWAYS relative to viewing plane
	//For gluLookAt the world coordinate position + the gluPerspective nearField give the 
	// near field clipping plane in world coordinates
	gluPerspective(45,ratio,1,100);
	//glOrtho(-2,2,-2,2,-2,2);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	vp_width = width; 
	vp_height = height;	
}

void specialKeys(int key, int x,int y)
{}


void move(int x, int y)
{}

void mouse(int button, int state, int x, int y)
{}

// Function called at exit
void Terminate(void)
{}